> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Personal Access Tokens

> Lists personal access tokens with optional filtering.

`Unary` · [`Users`](/docs/api-reference/generated/user/overview)

Lists personal access tokens with optional filtering.

Use this method to:

* View all active tokens
* Audit token usage
* Manage token lifecycle

### Examples

* List user tokens:

  Shows all tokens for specific users.

  ```yaml theme={null}
  filter:
    userIds: ["f53d2330-3795-4c5d-a1f3-453121af9c60"]
  pagination:
    pageSize: 20
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.UserService/ListPersonalAccessTokens
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.UserService/ListPersonalAccessTokens" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.pagination_pb2 as pagination_pb2
  import gitpod.v1.user_pb2 as user_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = user_pb2.ListPersonalAccessTokensRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.user.list_personal_access_tokens(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListPersonalAccessTokensRequestSchema } from "@gitpod/sdk/gitpod/v1/user_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListPersonalAccessTokensRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.user.listPersonalAccessTokens(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListPersonalAccessTokensRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.User.ListPersonalAccessTokens(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListPersonalAccessTokensRequest`

| Field        | Type                                                                 | Required | Description |
| ------------ | -------------------------------------------------------------------- | -------- | ----------- |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request)              | No       |             |
| `filter`     | [Filter](#type-gitpod-v1-list-personal-access-tokens-request-filter) | No       |             |

## Response

`gitpod.v1.ListPersonalAccessTokensResponse`

| Field                  | Type                                                                  | Required | Description |
| ---------------------- | --------------------------------------------------------------------- | -------- | ----------- |
| `pagination`           | [PaginationResponse](#type-gitpod-v1-pagination-response)             | No       |             |
| `personalAccessTokens` | array of [PersonalAccessToken](#type-gitpod-v1-personal-access-token) | No       |             |

## Related types

<a id="type-gitpod-v1-list-personal-access-tokens-request-filter" />

<Accordion title="Filter">
  `gitpod.v1.ListPersonalAccessTokensRequest.Filter`

  | Field     | Type            | Required | Description                                                                                                                                                                      |
  | --------- | --------------- | -------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `userIds` | array of string | No       | creator\_ids filters the response to only Environments created by specified members Constraints: `repeated.items.string.uuid=true, repeated.max_items=25, repeated.min_items=0`. |
</Accordion>

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>

<a id="type-gitpod-v1-personal-access-token" />

<Accordion title="PersonalAccessToken">
  `gitpod.v1.PersonalAccessToken`

  | Field         | Type                               | Required | Description                                                                                            |
  | ------------- | ---------------------------------- | -------- | ------------------------------------------------------------------------------------------------------ |
  | `id`          | string                             | No       | Constraints: `string.uuid=true`.                                                                       |
  | `userId`      | string                             | No       | Constraints: `string.uuid=true`.                                                                       |
  | `description` | string                             | No       |                                                                                                        |
  | `creator`     | [Subject](#type-gitpod-v1-subject) | No       |                                                                                                        |
  | `createdAt`   | RFC 3339 timestamp                 | No       |                                                                                                        |
  | `expiresAt`   | RFC 3339 timestamp                 | No       |                                                                                                        |
  | `lastUsed`    | RFC 3339 timestamp                 | No       |                                                                                                        |
  | `readOnly`    | boolean                            | No       | When true, the token can only be used for read operations. Mutations will be denied at the data layer. |
</Accordion>

<a id="type-gitpod-v1-subject" />

<Accordion title="Subject">
  `gitpod.v1.Subject`

  | Field       | Type                                   | Required | Description                                                                      |
  | ----------- | -------------------------------------- | -------- | -------------------------------------------------------------------------------- |
  | `id`        | string                                 | No       | id is the UUID of the subject Constraints: `ignore=1, string.uuid=true`.         |
  | `principal` | [Principal](#enum-gitpod-v1-principal) | No       | Principal is the principal of the subject Constraints: `enum.defined_only=true`. |
</Accordion>

<a id="enum-gitpod-v1-principal" />

<Accordion title="Principal">
  | Value                       | Number | Description |
  | --------------------------- | -----: | ----------- |
  | `PRINCIPAL_UNSPECIFIED`     |      0 |             |
  | `PRINCIPAL_ACCOUNT`         |      1 |             |
  | `PRINCIPAL_USER`            |      2 |             |
  | `PRINCIPAL_RUNNER`          |      3 |             |
  | `PRINCIPAL_ENVIRONMENT`     |      4 |             |
  | `PRINCIPAL_SERVICE_ACCOUNT` |      5 |             |
  | `PRINCIPAL_RUNNER_MANAGER`  |      6 |             |
</Accordion>
